# ImageQualityIndexes

[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]

ImageQualityIndexes provides the basic image quality assessment methods. Check the reasoning behind the code design [here](https://nextjournal.com/johnnychen94/the-principles-of-imagesjl-part-i) if you're interested in.

## Supported indexes

### Full reference indexes

* `PSNR`/`assess_psnr` -- Peak signal-to-noise ratio
* `SSIM`/`assess_ssim` -- Structural similarity
* `MSSSIM`/`assess_msssim` -- Multi-scale SSIM

### No-reference indexes

* `HASLER_AND_SUSSTRUNK_M3`/`hasler_and_susstrunk_m3` -- Colorfulness

## Basic usage

The root type is `ImageQualityIndex`, each concrete index is supposed to be one of `FullReferenceIQI`, `ReducedReferenceIQI` and `NoReferenceIQI`.

There are three ways to assess the image quality:

* use the general protocol, e.g., `assess(PSNR(), x, ref)`. This reads as "**assess** the image quality of **x** using method **PSNR** with information **ref**"
* each index instance is itself a function, e.g., `PSNR()(x, ref)`
* for well-known indexes, there are also convenient name for it for benchmark purpose.

For detailed usage of particular index, please check the docstring (e.g., `?PSNR`)

## Examples

```julia
using Images, TestImages
using ImageQualityIndexes

img = testimage("cameraman") .|> float64
noisy_img = img .+ 0.1 .* randn(size(img))
assess_ssim(noisy_img, img) # 0.24112
assess_psnr(noisy_img, img) # 19.9697

kernel = ones(3, 3)./9 # mean filter
denoised_img = imfilter(noisy_img, kernel)
assess_psnr(denoised_img, img) # 28.4249
assess_ssim(denoised_img, img) # 0.6390
assess_msssim(denoised_img, img) # 0.8460

img = testimage("fabio");
colorfulness(img) # 68.5530

```

<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageQualityIndexes.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageQualityIndexes.jl/workflows/Unit%20test/badge.svg
[action-url]: https://github.com/JuliaImages/ImageQualityIndexes.jl/actions
[codecov-img]: https://codecov.io/github/JuliaImages/ImageQualityIndexes.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageQualityIndexes.jl?branch=master

@testset "Entropy" begin
    type_list = generate_test_types([Float32, N0f8], [Gray, RGB])

    # generated by `rand(MersenneTwister(0), 1:10, 10, 10)` in Julia 1.7-rc2
    img = Gray{Float32}[
        5   2   4   8  10   8  10   2  6  10
        8  10  10   8   3   5  10   8  1   2
        5   5   1   6   8   9  10   2  8   1
        7   9   5   1  10   8   8   3  7   5
        9   9   2  10   5  10   1   3  7   1
        1   8   5   9   9   1   5  10  9  10
        8   5   6   1   7   5   2   6  3   6
        1   8   2   4   6   2   6   2  4   8
        4   5   2   8   7   2   4   7  2   8
       10   1   1   6   4   1   8   3  6   8
    ]./10
    img_repeat = repeat(img, inner=(2,2), outer=(2, 2))
    for T in generate_test_types([Float32, N0f8], [Gray, RGB])
        A, A_repeat = T.(img), T.(img_repeat)
        for (ref, kind) in [(3.2183821803676587, :shannon),
                            (2.230812534286212, :nat),
                            (0.9688295738011105, :hartley)]
            # entropy only cares the distribution of the values thus we check the equalities
            rst = entropy(A; kind=kind)
            @test rst ≈ entropy(A./2; kind=kind) ≈ entropy(A_repeat;kind=kind)
            @test rst ≈ ref
        end
    end

    # For BitMatrix we have faster implementation, here we check that it
    # is equivalent to the fallback method.
    img_bool = img .> 0.5
    img_float = Float32.(img_bool)
    for kind in [:shannon, :nat, :hartley]
        @test entropy(img_bool; kind=kind) == entropy(img_float; kind=kind)
    end

    @test_throws ArgumentError entropy(img, kind=:something_wrong)
end

"""
    SSIM([kernel], [(α, β, γ)]; crop=false) <: FullReferenceIQI
    assess(iqi::SSIM, img, ref)
    assess_ssim(img, ref; crop=false)

Structural similarity (SSIM) index is an image quality assessment method based
on degradation of structural information.

The SSIM index is composed of three components: luminance, contrast, and
structure; `ssim = 𝐿ᵅ * 𝐶ᵝ * 𝑆ᵞ`, where `W := (α, β, γ)` controls relative
importance of each components. By default `W = (1.0, 1.0, 1.0)`.

In practice, a mean version SSIM is used. At each pixel, SSIM is calculated
locally with neighborhoods weighted by `kernel`, returning a ssim map;
`ssim` is actaully `mean(ssim_map)`.
By default `kernel = KernelFactors.gaussian(1.5, 11)`.

!!! tip

    The default parameters comes from [1]. For benchmark usage, it is recommended to not
    change the parameters, because most other SSIM implementations follows the same settings.
    Keyword `crop` controls whether the boundary of ssim map should be dropped; you need
    to set it `true` to reproduce the result in [1].

# Example

`assess_ssim(img, ref)` should be sufficient to get a benchmark for algorithms. One
could also instantiate a customed SSIM, then pass it to `assess` or use it as a
function. For example:

```julia
iqi = SSIM(KernelFactors.gaussian(2.5, 17), (1.0, 1.0, 2.0))
assess(iqi, img, ref)
iqi(img, ref) # both usages are equivalent
```

!!! info

    SSIM is defined only for gray images. How `RGB` and other `Color3` images are handled may vary
    in different implementations. For `RGB` images, channels are handled seperately when calculating
    𝐿, 𝐶, and 𝑆. Generic `Color3` images are converted to `RGB` first before calculation.

# Reference

[1] Wang, Z., Bovik, A. C., Sheikh, H. R., & Simoncelli, E. P. (2004). Image quality assessment: from error visibility to structural similarity. _IEEE transactions on image processing_, 13(4), 600-612.

[2] Wang, Z., Bovik, A. C., Sheikh, H. R., & Simoncelli, E. P. (2003). The SSIM Index for Image Quality Assessment. Retrived May 30, 2019, from http://www.cns.nyu.edu/~lcv/ssim/
"""
struct SSIM{A<:AbstractVector} <: FullReferenceIQI
    kernel::A
    W::NTuple{3, Float64}
    crop::Bool
    function SSIM(kernel::AbstractVector=SSIM_KERNEL, W::NTuple=SSIM_W; crop=false)
        ndims(kernel) == 1 || throw(ArgumentError("only 1-d kernel is valid"))
        issymetric(kernel) || @warn "SSIM kernel is assumed to be symmetric"
        all(W .>= 0) || throw(ArgumentError("(α, β, γ) should be non-negative, instead it's $(W)"))
        kernel = OffsetArrays.centered(kernel)
        new{typeof(kernel)}(kernel, W, crop)
    end
end

# default values from [1]
# kernel generated from ImageFiltering.KernelFactors.gaussian(1.5, 11)
# don't use ImageFiltering directly here because we lazy-import that dependency
const SSIM_KERNEL = OffsetArray([0.00102838008447911,
        0.007598758135239185,
        0.03600077212843083,
        0.10936068950970002,
        0.2130055377112537,
        0.26601172486179436,
        0.2130055377112537,
        0.10936068950970002,
        0.03600077212843083,
        0.007598758135239185,
        0.00102838008447911,], -5:5)
const SSIM_W = (1.0, 1.0, 1.0) # (α, β, γ)

Base.:(==)(ia::SSIM, ib::SSIM) = ia.kernel == ib.kernel && ia.W == ib.W && ia.crop == ib.crop

# api
# By default we don't crop the padding boundary to match the ssim result from
# MATLAB Image Processing Toolbox, which is used more broadly than the original
# implementaion [2] (written in MATLAB as well).
# -- Johnny Chen <johnnychen94@hotmail.com>
(iqi::SSIM)(x, ref) = mean(_ssim_map(iqi, x, ref))

@doc (@doc SSIM)
assess_ssim(x, ref; crop=false) = SSIM(;crop=crop)(x, ref)

# Parameters `(K₁, K₂)` are used to avoid instability when denominator is very
# close to zero. Different from origianl implementation [2], we don't make it
# public since the ssim result is insensitive to these parameters according to
# [1].
# -- Johnny Chen <johnnychen94@hotmail.com>
const SSIM_K = (0.01, 0.03)

# SSIM is defined only for gray images,
# RGB images are treated as 3d gray images,
# other Color3 images are converted to RGB first.
function _ssim_map(iqi::SSIM,
                   x::Union{GenericGrayImage, AbstractArray{<:AbstractRGB}},
                   ref::Union{GenericGrayImage, AbstractArray{<:AbstractRGB}},
                   peakval = 1.0,
                   K = SSIM_K)
    if size(x) ≠ size(ref)
        err = ArgumentError("images should be the same size, instead they're $(size(x))-$(size(ref))")
        throw(err)
    end
    if axes(x) ≠ axes(ref)
        x = OffsetArrays.no_offset_view(x)
        ref = OffsetArrays.no_offset_view(ref)
    end
    α, β, γ = iqi.W
    C₁, C₂ = @. (peakval * K)^2
    C₃ = C₂/2

    T = promote_type(float(eltype(ref)), float(eltype(x)))
    x = of_eltype(T, x)
    ref = of_eltype(T, ref)

    if [α, β, γ] ≈ [1.0, 1.0, 1.0]
        ssim_map = __ssim_map_fast(x, ref, iqi.kernel, C₁, C₂; crop=iqi.crop)
    else
        l, c, s = __ssim_map_general(x, ref, iqi.kernel, C₁, C₂, C₃; crop=iqi.crop)
        # ensure that negative numbers in s are not being raised to powers less than 1
        # this is a non-standard implementation and it could vary from implementaion to implementaion
        γ < 1.0 && (s = max.(s, zero(eltype(s))))
        ssim_map = @. l^α * c^β * s^γ # equation (12) in [1]
    end
    return ssim_map
end

function _ssim_map(iqi::SSIM,
          x::AbstractArray{<:Color3},
          ref::AbstractArray{<:Color3},
          peakval = 1.0, K = SSIM_K)
    C = ccolor(RGB, floattype(eltype(x)))
    _ssim_map(iqi, of_eltype(C, x), of_eltype(C, ref), peakval, K)
end


# helpers
function issymetric(kernel)
    origin = first(axes(kernel, 1))
    center = (length(kernel)-1) ÷ 2 + origin
    kernel[origin:center] ≈ kernel[end:-1:center]
end


function __ssim_map_fast(x, ref, window, C₁, C₂; crop)
    μx², μxy, μy², σx², σxy, σy² = _ssim_statistics(x, ref, window; crop=crop)
    # this is a special case when [α, β, γ] ≈ [1.0, 1.0, 1.0]
    # equation (13) in [1]
    return @. ((2μxy + C₁)*(2σxy + C₂))/((μx²+μy²+C₁)*(σx² + σy² + C₂))
end

function __ssim_map_general(x, ref, window, C₁, C₂, C₃; crop)
    μx², μxy, μy², σx², σxy, σy² = _ssim_statistics(x, ref, window; crop = crop)

    T = eltype(σx²)
    σx_σy = @. sqrt( max(σx²*σy², zero(T) ))
    l = @. (2μxy + C₁)/(μx² + μy²) # equation (6) in [1]
    c = @. (2σx_σy + C₂)/(σx² + σy² + C₂) # equation (9) in [1]
    s = @. (σxy + C₃)/(σx_σy + C₃) # equation (10) in [1]

    # MS-SSIM needs these, so we don't multiply them together here
    return l, c, s
end

function _ssim_statistics(x::GenericImage, ref::GenericImage, window; crop)
    # For RGB and other Color3 images, we don't slide the window at the color channel.
    # In other words, these characters will be calculated channelwisely

    region = map(axes(x)) do a
        o = length(window) ÷ 2
        # Even if crop=true, it crops only when image is larger than window
        length(a) > length(window) ? (first(a)+o:last(a)-o) : a
    end
    R = crop ? CartesianIndices(region) : CartesianIndices(x)

    window = ImageFiltering.kernelfactors(Tuple(repeated(window, ndims(ref))))

    # don't slide the window in the channel dimension
    μx = view(ImageFiltering.imfilter(x,   window, "symmetric"), R) # equation (14) in [1]
    μy = view(ImageFiltering.imfilter(ref, window, "symmetric"), R) # equation (14) in [1]
    μx² = _mul.(μx, μx)
    μy² = _mul.(μy, μy)
    μxy = _mul.(μx, μy)
    σx² = view(ImageFiltering.imfilter(_mul.(x,   x  ), window, "symmetric"), R) .- μx² # equation (15) in [1]
    σy² = view(ImageFiltering.imfilter(_mul.(ref, ref), window, "symmetric"), R) .- μy² # equation (15) in [1]
    σxy = view(ImageFiltering.imfilter(_mul.(x,   ref), window, "symmetric"), R) .- μxy # equation (16) in [1]

    # after that, channel dimension can be treated generically so we expand them here
    return channelview.((μx², μxy, μy², σx², σxy, σy²))
end

# _ssim_statistics does not expected to work with other Color3 types
@inline _mul(x::Number, y::Number) = x * y
@inline _mul(x::C, y::C) where C <: Union{AbstractGray, AbstractRGB} = mapc(*, x, y)

using PrecompileTools

@setup_workload begin
    imgs_list = Any[
        [rand(Gray{N0f8}, 32, 32) for _ in 1:2],
        [rand(RGB{N0f8}, 32, 32) for _ in 1:2],
        [rand(Gray{Float64}, 32, 32) for _ in 1:2],
        [rand(RGB{Float64}, 32, 32) for _ in 1:2],
        [rand(N0f8, 32, 32) for _ in 1:2],
        [rand(Float64, 32, 32) for _ in 1:2],
    ]
    @compile_workload begin
        for imgs in imgs_list
            assess_psnr(imgs...)
            assess_ssim(imgs...)
        end
    end
end

@testset "MS-SSIM" begin
    @info "test: MS-SSIM"

    # constructors
    iqi_a = MSSSIM()
    iqi_b = MSSSIM(KernelFactors.gaussian(1.5, 11))
    iqi_c = MSSSIM(KernelFactors.gaussian(1.5, 11), (0.0448, 0.2856, 0.3001, 0.2363, 0.1333))
    iqi_d = MSSSIM(KernelFactors.gaussian(1.5, 11), (
        (0.0448, 0.0448, 0.0448),
        (0.2856, 0.2856, 0.2856),
        (0.3001, 0.3001, 0.3001),
        (0.2363, 0.2363, 0.2363),
        (0.1333, 0.1333, 0.1333),
    ))
    iqi_e = MSSSIM(; num_scales=5)
    iqi_f = @suppress_err MSSSIM(KernelFactors.gaussian(1.5, 11), 2 .* (0.0448, 0.2856, 0.3001, 0.2363, 0.1333))
    @test iqi_a == iqi_b == iqi_c == iqi_d == iqi_e == iqi_f

    output = @capture_err begin
        MSSSIM(KernelFactors.gaussian(1.5, 11), (0.0448, 0.2856, 0.3001))
    end
    @test output == ""
    output = @capture_err begin
        MSSSIM(KernelFactors.gaussian(1.5, 11), (0.1, 0.3, 0.6); num_scales=1)
    end
    @test occursin("truncate MS-SSIM weights to scale", output)
    @test occursin("normalize MS-SSIM weights so that (∑α, ∑β, ∑γ) == (1.0, 1.0, 1.0)", output)

    # Gray test images
    img1 = testimage("fabio_gray_512")
    img2 = testimage("lena_gray_512")
    # Tensorflow, pytorch_msssim and MATLAB original implementation: 0.1072
    # We have strong reason to suspect that MSSSIM in MATLAB R2020a is incorrect
    # https://github.com/JuliaImages/ImageQualityIndexes.jl/pull/19#issuecomment-655208537
    @test assess_msssim(img1, img2) ≈ 0.11109 atol=1e-4
    @test assess(MSSSIM(), img1, img2) ≈ MSSSIM()(img1, img2)

    # RGB test images
    # MS-SSIM in MATLAB R2020a and its original implementation only support Gray images
    img3 = testimage("mandril_color")
    img4 = testimage("lena_color_512")
    @test assess_msssim(img3, img4) ≈ 0.08516 atol=1e-4 # pytorch_msssim: 0.0786
    @test assess(MSSSIM(), img3, img4) ≈ MSSSIM()(img3, img4)

    # Varying αᵢ, βᵢ, γᵢ
    iqi_e = @suppress_err MSSSIM(KernelFactors.gaussian(1.5, 11), (
        (0.0448, 0.2856, 0.3001),
        (0.3001, 0.0448, 0.2856),
        (0.2856, 0.3001, 0.0448),
    ))
    @test iqi_e(img3, img4) ≈ 0.13109 atol=1e-4
    # non standard parameters, result may differ from other implementations

    # Comparing with SSIM
    iqi_f = MSSSIM(KernelFactors.gaussian(1.5, 11), (1, ))
    @test iqi_f(img3, img4) ≈ SSIM()(img3, img4) atol=1e-3

    # images should have the same size, but their axes can differs
    @test assess_msssim(img1, OffsetArray(img2, -2, -2)) == assess_msssim(img1, img2)
    @test_throws ArgumentError assess_msssim(img1, restrict(img2))

    # RGB - Gray
    @test assess_msssim(img3, Gray.(img4)) == assess_msssim(img3, RGB.(Gray.(img4)))
    @test assess_msssim(img3, img4) ≠ assess_msssim(channelview(img3), channelview(img4))

    # Gray type tests
    type_list = generate_test_types([Float32, N0f8], [Gray])
    A = rand(128,128)
    B = rand(128,128)

    for T in type_list

        a = A .|> T
        b = B .|> T

        @test assess_msssim(a, b) == assess(MSSSIM(), a, b) == MSSSIM()(a, b)
        @test assess_msssim(a, a) ≈ 1.0 atol=1e-4
        @test assess_msssim(a, b; num_scales=1) == assess(MSSSIM(num_scales=1), a, b) == MSSSIM(num_scales=1)(a, b)
    end

    # check if numbers are treated the same as gray colorants
    a = Gray.(A)
    b = Gray.(B)
    @test assess_msssim(a, b) ≈ assess_msssim(A, B)


    # RGB type tests
    type_list = generate_test_types([Float32, N0f8], [RGB])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]

    for T in type_list

        a = A .|> T
        b = B .|> T

        @test assess_msssim(a, b) == assess(MSSSIM(), a, b) == MSSSIM()(a, b)
        @test assess_msssim(a, a) ≈ 1.0 atol=1e-4
        @test assess_msssim(a, b; num_scales=1) == assess(MSSSIM(num_scales=1), a, b) == MSSSIM(num_scales=1)(a, b)
    end

    # Other Color3 type tests
    type_list = generate_test_types([Float32], [Lab, HSV])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        a = A .|> T
        b = B .|> T

        @test_nowarn assess_msssim(A, b), assess_msssim(a, B)

        @test assess_msssim(a, b) == assess(MSSSIM(), a, b) == MSSSIM()(a, b)
        @test assess_msssim(a, a) ≈ 1.0 atol=1e-4
        @test assess_msssim(a, b; num_scales=1) == assess(MSSSIM(num_scales=1), a, b) == MSSSIM(num_scales=1)(a, b)

    end
    @test assess_msssim(A, B) ≈ assess_msssim(Lab.(A), B) atol=1e-4

    type_list = generate_test_types([Float32, N0f8], [RGB, BGR])
    test_cross_type(MSSSIM(), A, B, type_list)
end

@testset "colorfulness" begin
    
    @info "test: colorfulness"

    # Test against a simple result calculated by hand
    
    x = [RGB(1,0,0), RGB(0,1,0), RGB(0,0,1)]
    @test trunc(colorfulness(x)) == 337

    # Black is not colorful
    
    x = [RGB(0,0,0), RGB(0,0,0), RGB(0,0,0)]
    @test trunc(colorfulness(x)) == 0

    # White is not colorful
    
    x = [RGB(1,1,1), RGB(1,1,1), RGB(1,1,1)]
    @test trunc(colorfulness(x)) == 0

    # A grayscale image is not colorful
    
    cameraman = testimage("cameraman")
    @test colorfulness(cameraman) == 0

    # A color image with only grays is not colorful
    
    x = convert(Array{Float64}, cameraman)
    img = RGB.(x, x, x)
    @test colorfulness(img) == 0
    
    # Lena 256 is a reduced color image and so should be less colorful
    # than the original

    imga = testimage("lena_color_256")
    imgb = testimage("lena_color_512")
    
    @test  colorfulness(imga) < colorfulness(imgb) 
   
    # Test all invocation styles are equivalent
    
    c1 = colorfulness(imga)
    c2 = hasler_and_susstrunk_m3(imga)
    c3 = colorfulness(HASLER_AND_SUSSTRUNK_M3(), imga)
    c4 = assess(HASLER_AND_SUSSTRUNK_M3(), imga)

    @test c1 == c2 == c3 == c4
    
end

"""

    HASLER_AND_SUSSTRUNK_M3 <: NoReferenceIQI
    M =  hasler_and_susstrunk_m3(img)

Calculates the colorfulness of a natural image using method M3 from
[1]. As a guide to interpretation of results, the authors suggest:

| Attribute           | M3 |
|:--------------------|----|
| Not colorful        |  0 |
| slightly colorful   | 15 |
| moderately colorful | 33 |
| averagely colorful  | 45 |
| quite colorful      | 59 |
| highly colorful     | 82 |
| extremely colorful  |109 |

[1] Hasler, D. and Süsstrunk, S.E., 2003, June. Measuring colorfulness
in natural images. In Human vision and electronic imaging VIII
(Vol. 5007, pp. 87-96). International Society for Optics and
Photonics.

"""
struct HASLER_AND_SUSSTRUNK_M3 <: NoReferenceIQI end

# api
(iqi::HASLER_AND_SUSSTRUNK_M3)(img) = hasler_and_susstrunk_m3(img)

@doc (@doc HASLER_AND_SUSSTRUNK_M3)
function hasler_and_susstrunk_m3(img::AbstractArray{<:AbstractRGB})

    R = 255 .* float(red.(img))
    G = 255 .* float(green.(img))
    B = 255 .* float(blue.(img))

    rg = R .- G 
    μrg, σrg = mean(rg), std(rg)
   
    yb = 0.5 .* (R .+ G) .- B
    μyb,  σyb = mean(yb), std(yb)

    μrgyb = sqrt(μrg^2 + μyb^2)
    σrgyb = sqrt(σrg^2 + σyb^2)

    return σrgyb + 0.3 * μrgyb

end

hasler_and_susstrunk_m3(img::GenericGrayImage) = 0

"""
     M =  colorfulness(img)
     M =  colorfulness(HASLER_AND_SUSSTRUNK_M3(), img)

Measures the colorfulness of a natural image. Uses the
[`HASLER_AND_SUSSTRUNK_M3`](@ref) method by default.

See also: [`HASLER_AND_SUSSTRUNK_M3`](@ref).

"""
colorfulness(m::HASLER_AND_SUSSTRUNK_M3, img) = m(img)

colorfulness(img) = HASLER_AND_SUSSTRUNK_M3()(img)

@testset "world age issue" begin
    img = rand(Gray, 64, 64)
    @testset "ssim" begin
        foo() = assess_ssim(img, img)
        @test foo() == 1.0
    end
    @testset "psnr" begin
        foo() = assess_psnr(img, img)
        @test foo() == Inf
    end
    @testset "entropy" begin
        foo() = entropy(img)
        @test_nowarn foo()
    end
end

using ImageQualityIndexes
using Test
using ImageCore

# For lazily imported packages, world age issue might occur at first call, these tests must
# be put first.
include("world_age_issue.jl")

using ReferenceTests, TestImages
using Suppressor
using Statistics
using OffsetArrays
using ImageTransformations
using ImageFiltering

include("testutils.jl")

@testset "ImageQualityIndexes" begin

    include("psnr.jl")
    include("ssim.jl")
    include("msssim.jl")
    include("colorfulness.jl")
    include("entropy.jl")

end

nothing

"""
    abstract type ImageQualityIndex <: Any

Root of `ImageQualityIndexes` type hierarchy.

Classified by whether a reference image is needed, there are three more abstract types defined: [`FullReferenceIQI`](@ref), [`ReducedReferenceIQI`](@ref) and [`NoReferenceIQI`](@ref)

!!! info

    Image quality index is also known as image quality assessment, image quality metrics and image quality methods.

# References

[1] Wang, Z., & Bovik, A. C. (2006). _Modern Image Quality Assessment_. Morgan & Claypool Publishers.
"""
abstract type ImageQualityIndex end

"""
    abstract type FullReferenceIQI <: ImageQualityIndex
    assess(::FullReferenceIQI, img, ref_img, args...)

Image quality index that requires its reference to be complete/full image or image series.

See also: [`ImageQualityIndex`](@ref), [`ReducedReferenceIQI`](@ref), [`NoReferenceIQI`](@ref)
"""
abstract type FullReferenceIQI <: ImageQualityIndex end

"""
    abstract type ReducedReferenceIQI <: ImageQualityIndex
    assess(::ReducedReferenceIQI, img, ref_info, args...)

Image quality index that requires some information from reference image.

Different from [`FullReferenceIQI`](@ref), `ReducedReferenceIQI` doesn't need the complete reference image.

See also: [`ImageQualityIndex`](@ref), [`FullReferenceIQI`](@ref), [`NoReferenceIQI`](@ref)
"""
abstract type ReducedReferenceIQI <: ImageQualityIndex end

"""
    abstract type NoReferenceIQI <: ImageQualityIndex
    assess(::NoReferenceIQI, img, args...)

Image quality index that doesn't require any information.

See also: [`ImageQualityIndex`](@ref), [`FullReferenceIQI`](@ref), [`ReducedReferenceIQI`](@ref)
"""
abstract type NoReferenceIQI <: ImageQualityIndex end

@doc (@doc FullReferenceIQI)
assess(iqi::FullReferenceIQI, x, ref, args...) = iqi(x, ref, args...)

@doc (@doc ReducedReferenceIQI)
assess(iqi::ReducedReferenceIQI, x, ref, args...) = iqi(x, ref, args...)

@doc (@doc NoReferenceIQI)
assess(iqi::NoReferenceIQI, x, args...) = iqi(x, args...)

using ImageFiltering

@testset "SSIM" begin
    @info "test: SSIM"

    # ensure the precomputed value for SSIM_KERNEL is correct
    @test ImageQualityIndexes.SSIM_KERNEL == ImageQualityIndexes.ImageFiltering.KernelFactors.gaussian(1.5, 11)

    iqi_a = SSIM()
    iqi_b = SSIM(KernelFactors.gaussian(1.5, 11))
    iqi_c = SSIM(KernelFactors.gaussian(1.5, 11), (1.0, 1.0, 1.0))
    iqi_d = SSIM(KernelFactors.gaussian(1.5, 11), (1.0, 1.0, 1.0); crop=false)
    @test iqi_a == iqi_b == iqi_c == iqi_d
    @test SSIM(; crop=true) == SSIM(KernelFactors.gaussian(1.5, 11), (1.0, 1.0, 1.0); crop=true)

    iqi = SSIM()
    sz_img_3 = (3, 3, 3)

    # numerical test
    img1 = testimage("cameraman")
    img2 = testimage("lena_gray_512")
    @test assess_ssim(img1, img2; crop=false) ≈ 0.3595 atol=1e-4 # MATLAB built-in ssim result
    @test assess_ssim(img1, img2; crop=true) ≈ 0.3526 atol=1e-4 # MATLAB original ssim result & tensorflow implementation

    # this calls the general implementation
    iqi_δ1 = SSIM(KernelFactors.gaussian(1.5, 11), (1.0+1e-5, 1.0, 1.0))
    @test assess(iqi_δ1, img1, img2) ≈ assess(SSIM(), img1, img2) atol = 1e-4
    # this calls the general implementation with max.(s, 0)
    iqi_δ2 = SSIM(KernelFactors.gaussian(1.5, 11), (1.0, 1.0, 1.0-1e-5))
    @test assess(iqi_δ2, img1, img2) ≈ assess(SSIM(), img1, img2) atol = 1e-2

    # non-standard powers
    iqi_γ = SSIM(KernelFactors.gaussian(1.5, 11), (0.5, 0.5, 0.5))
    @test iqi_γ(img1, img2) ≈ 0.5261 atol=1e-4
    # non standard parameters, result may differ from other implementations

    # images should have the same size, but their axes can differs
    @test assess_ssim(img1, OffsetArray(img2, -2, -2)) == assess_ssim(img1, img2)
    @test_throws ArgumentError assess_ssim(img1, restrict(img2))

    # Gray image
    type_list = generate_test_types([Bool, Float32, N0f8], [Gray])
    A = [1.0 1.0 1.0; 1.0 1.0 1.0; 0.0 0.0 0.0]
    B = [1.0 1.0 1.0; 0.0 0.0 0.0; 1.0 1.0 1.0]
    for T in type_list
        test_ndarray(iqi, sz_img_3, T)

        a = A .|> T
        b = B .|> T

        @test assess_ssim(a, b) == assess_ssim(a, b; crop = false) == assess(SSIM(), a, b) == SSIM()(a, b)
        @test assess_ssim(a, b; crop = true) == assess(SSIM(crop = true), a, b) == SSIM(crop = true)(a, b)
        @test assess_ssim(a, a) ≈ 1.0

        # FIXME: the result of Bool type is not strictly equal to others
        eltype(T) <: Bool && continue
        test_numeric(iqi, a, b, T; filename="references/SSIM_2d_Gray")
        test_numeric(iqi, channelview(a), channelview(b), T; filename="references/SSIM_2d_Gray")
    end
    test_cross_type(iqi, A, B, type_list)

    # RGB image
    img1 = testimage("mandril_color")
    img2 = testimage("lena_color_512")
    # this differs from MATLAB built-in result as our implementation don't slide the window in the channel dimension
    @test assess_ssim(img1, img2; crop=false) ≈ 0.11069226443828077 atol=1e-4 # MATLAB built-in: 0.0664
    @test assess_ssim(img1, img2; crop=true) ≈ 0.10967952100784095 atol=1e-4 # the original implementation: 0.1047

    # gray images are promoted to RGB images before calculation
    img3 = testimage("lena_gray_512")
    @test assess_ssim(img2, img3) == assess_ssim(img2, RGB.(img3))
    @test assess_ssim(img2, img3) ≠ assess_ssim(Gray.(img2), img3)

    type_list = generate_test_types([Float32, N0f8], [RGB])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        test_ndarray(iqi, sz_img_3, T)

        a = A .|> T
        b = B .|> T

        @test assess_ssim(a, b; crop = false) == assess_ssim(a, b) == assess(SSIM(), a, b) == SSIM()(a, b)
        @test assess_ssim(a, b; crop = true) == assess(SSIM(crop = true), a, b) == SSIM(crop = true)(a, b)
        @test assess_ssim(a, b) ≠ assess_ssim(channelview(a), channelview(b))
        @test assess_ssim(a, a) ≈ 1.0

        # RGB is treated as 3d gray image
        test_numeric(iqi, a, b, T; filename="references/SSIM_2d_RGB")
    end
    type_list = generate_test_types([Float32, N0f8], [RGB, BGR])
    test_cross_type(iqi, A, B, type_list)

    # general Color3 images
    type_list = generate_test_types([Float32], [Lab, HSV])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        a = A .|> T
        b = B .|> T

        @test_nowarn assess_ssim(A, b), assess_ssim(a, B)

        @test assess_ssim(a, b; crop = false) == assess_ssim(a, b) == assess(SSIM(), a, b) == SSIM()(a, b)
        @test assess_ssim(a, b; crop = true) == assess(SSIM(crop = true), a, b) == SSIM(crop = true)(a, b)
        @test assess_ssim(a, a) ≈ 1.0

        # conversion to RGB first differs from no conversion
        @test assess_ssim(a, b) ≠ assess_ssim(channelview(a), channelview(b))
    end
    @test assess_ssim(A, B) ≈ assess_ssim(Lab.(A), B) atol=1e-4
end

@testset "PSNR" begin
    @info "test: PSNR"

    iqi = PSNR()
    sz_img_3 = (3, 3, 3)

    # Gray image
    type_list = generate_test_types([Bool, Float32, N0f8], [Gray])
    A = [1.0 1.0 1.0; 1.0 1.0 1.0; 0.0 0.0 0.0]
    B = [1.0 1.0 1.0; 0.0 0.0 0.0; 1.0 1.0 1.0]
    for T in type_list
        test_ndarray(iqi, sz_img_3, T)

        a = A .|> T
        b = B .|> T

        # scalar output
        @test assess_psnr(a, b) == assess(PSNR(), a, b)
        @test assess_psnr(a, b) == assess_psnr(a, b, 1.0)
        @test isinf(assess_psnr(a, a))

        # vector output
        @test size(assess_psnr(a, b, [1.0])) == (1,)
        @test mean(assess_psnr(a, b, [1.0])) == assess_psnr(a, b, 1.0)
        @test all(isinf.(assess_psnr(a, a, [1.0])))

        # FIXME: the result of Bool type is not strictly equal to others
        eltype(T) <: Bool && continue
        test_numeric(iqi, a, b, T)
        test_numeric(iqi, channelview(a), channelview(b), T)
    end
    test_cross_type(iqi, A, B, type_list)

    # RGB image
    type_list = generate_test_types([Float32, N0f8], [RGB])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        test_ndarray(iqi, sz_img_3, T)

        a = A .|> T
        b = B .|> T

        # scalar output
        @test assess_psnr(a, b) == assess(PSNR(), a, b) == PSNR()(a, b)
        @test assess_psnr(a, b) == assess_psnr(a, b, 1.0) == PSNR()(a, b, 1.0)
        @test assess_psnr(a, b) == assess_psnr(channelview(a), channelview(b))
        @test isinf(assess_psnr(a, a))

        # vector output
        @test_throws ArgumentError assess_psnr(a, b, [1.0])
        @test assess_psnr(a, b, [1.0, 1.0, 1.0]) == assess(PSNR(), a, b, [1.0, 1.0, 1.0]) == PSNR()(a, b, [1.0, 1.0, 1.0])
        @test size(assess_psnr(a, b, [1.0, 1.0, 1.0])) == (3,)
        @test mean(assess_psnr(a, b, [1.0, 1.0, 1.0])) != assess_psnr(a, b) # generally they doesn't equal
        @test all(isinf.(assess_psnr(a, a, [1.0, 1.0, 1.0])))

        test_numeric(iqi, a, b, T)
        test_numeric(iqi, channelview(a), channelview(b), T; filename="references/PSNR_2d_RGB")
    end
    type_list = generate_test_types([Float32, N0f8], [RGB, BGR])
    test_cross_type(iqi, A, B, type_list)
    @test isapprox(assess_psnr(Lab.(A), B), assess_psnr(A, B); rtol=1e-5)

    # general Color3 images that doesn't have peakval inferred
    type_list = generate_test_types([Float32], [Lab, HSV])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        a = A .|> T
        b = B .|> T

        @test assess_psnr(a, b, [1.0, 1.0, 1.0]) == assess(PSNR(), a, b, [1.0, 1.0, 1.0]) == PSNR()(a, b, [1.0, 1.0, 1.0])
        @test all(isinf.(assess_psnr(A, A, [1.0, 1.0, 1.0])))
    end
end

"""
    entropy(logᵦ, img; nbins=256)
    entropy(img; kind=:shannon, nbins=256)

Compute the entropy of an image signal defined as `-sum(p.*logᵦ(p))`, where p is the
histogram of the image.

The base β of the logarithm (a.k.a. entropy unit) is one of the following:

- `:shannon ` (log base 2, default), or use logᵦ = log2
- `:nat` (log base e), or use logᵦ = log
- `:hartley` (log base 10), or use logᵦ = log10

The keyword `nbins` controls how histogram is calculated.

# Examples

```jldoctest; setup=:(using ImageQualityIndexes, Random; Random.seed!(0))
julia> img = rand(1:10, 5, 5)
5×5 $(Matrix{Int}):
 2  8   2  5  6
 7  9   2  7  3
 7  8   8  1  3
 3  1   3  9  4
 5  7  10  4  6

julia> entropy(img)
3.223465189601647

julia> entropy(log2, img) # kind=:shannon
3.223465189601647

julia> entropy(img; kind=:nat)
2.234335807805511
```

As long as the distributions (histograms) are the same, the entropys will be the same as
well:

```jldoctest; setup=:(using ImageQualityIndexes, ImageCore, Random; Random.seed!(0))
julia> img = rand(Gray, 5, 5);

julia> entropy(img)
4.5638561897747225

julia> entropy(RGB.(img))
4.5638561897747225

julia> entropy(repeat(img, inner=(2, 2), outer=(2, 2)))
4.5638561897747225
```
"""
entropy(img::AbstractArray; kind=:shannon, nbins=256) = entropy(_log(kind), img; nbins=nbins)
function entropy(logᵦ::Log, img; nbins=256) where Log<:Function
    _, counts = ImageContrastAdjustment.build_histogram(img, nbins)
    n = length(img)
    _zero = zero(first(counts)/n)
    -sum(counts) do c
        c>0 ? c/n * logᵦ(c/n) : _zero
    end
end
function entropy(logᵦ::Log, img::AbstractArray{Bool}) where Log<:Function
    # for binary image, the histogram is just [length(img) - sum(img), sum(img)]
    p = sum(img) / length(img)
    (0 < p < 1) ? - p*logᵦ(p) - (1-p)*logᵦ(1-p) : zero(p)
end

function _log(kind::Symbol)
    if kind == :shannon
        return log2
    elseif kind == :nat
        return log
    elseif kind == :hartley
        return log10
    else
        throw(ArgumentError("Invalid entropy unit: `$kind`. It should be one of `:shannon`, `:nat` or `:hartley`"))
    end
end

"""
    PSNR <: FullReferenceIQI
    assess(PSNR(), x, ref, [, peakval])
    assess_psnr(x, ref [, peakval])

Peak signal-to-noise ratio (PSNR) is used to measure the quality of image in
present of noise and corruption.

For gray image `x`, PSNR (in dB) is calculated by
`10log10(peakval^2/mse(x, ref))`, where `peakval` is the maximum possible pixel
value of image `ref`. `x` will be converted to type of `ref` when necessary.

Generally, for non-gray image `x`, PSNR is reported against each channel of
`ref` and outputs a `Vector`, `peakval` needs to be a vector as well.

!!! info

    Conventionally, `m×n` rgb image is treated as `m×n×3` gray image. To
    calculated channelwise PSNR of rgb image, one could pass `peakval` as
    vector, e.g., `psnr(x, ref, [1.0, 1.0, 1.0])`
"""
struct PSNR <: FullReferenceIQI end

# api
(iqi::PSNR)(x, ref, peakval) = _assess_psnr(x, ref, peakval)
(iqi::PSNR)(x, ref) = iqi(x, ref, peak_value(eltype(ref)))

@doc (@doc PSNR)
assess_psnr(x, ref, peakval) = _assess_psnr(x, ref, peakval)
assess_psnr(x, ref) = assess_psnr(x, ref, peak_value(eltype(ref)))


# implementation
""" Define the default peakval for colors, specialize gray and rgb to get scalar output"""
peak_value(::Type{T}) where T <: Colorant = gamutmax(T)
peak_value(::Type{T}) where T <: NumberLike = one(eltype(T))
peak_value(::Type{T}) where T <: AbstractRGB = one(eltype(T))

_assess_psnr(x::GenericGrayImage, ref::GenericGrayImage, peakval::Real)::Real =
    20log10(peakval) - 10log10(ImageDistances.mse(x, ref))

# convention & backward compatibility for RGB images
# m*n RGB images are treated as m*n*3 gray images
function _assess_psnr(x::GenericImage{<:Color3}, ref::GenericImage{<:AbstractRGB},
               peakval::Real)::Real
    _assess_psnr(channelview(of_eltype(eltype(ref), x)), channelview(ref), peakval)
end

# general channelwise definition: each channel is calculated independently
function _assess_psnr(x::GenericImage{<:Color3}, ref::GenericImage{CT},
              peakvals)::Vector where {CT<:Color3}
    check_peakvals(CT, peakvals)

    newx = of_eltype(CT, x)
    cx, ax = channelview(newx), axes(newx)
    cref, aref = channelview(ref), axes(ref)
    [_assess_psnr(view(cx, i, ax...),
                   view(cref, i, aref...),
                   peakvals[i]) for i in 1:length(CT)]
end
function _assess_psnr(x::GenericGrayImage, ref::GenericGrayImage,
      peakval)::Vector
    check_peakvals(eltype(ref), peakval)

    [_assess_psnr(x, ref, peakval[1]), ]
end

_length(x) = length(x)
_length(x::Type{T}) where T<:Number = 1
function check_peakvals(CT, peakvals)
    if _length(peakvals) ≠ _length(CT)
        err_msg = "peakvals for PSNR should be length-$(length(CT)) vector for $(base_colorant_type(CT)) images"
        throw(ArgumentError(err_msg))
    end
end

module ImageQualityIndexes

using LazyModules
using OffsetArrays
using ImageCore
# Where possible we avoid a direct dependency to reduce the number of [compat] bounds
using ImageCore.MappedArrays
using ImageCore: NumberLike, Pixel, GenericImage, GenericGrayImage
@lazy import ImageDistances = "51556ac3-7006-55f5-8cb3-34580c88182d"
@lazy import ImageContrastAdjustment = "f332f351-ec65-5f6a-b3d1-319c6670881a"
@lazy import ImageFiltering = "6a3955dd-da59-5b1f-98d4-e7296123deb5"
using Statistics: mean, std
using Base.Iterators: repeated, flatten

include("generic.jl")
include("psnr.jl")
include("ssim.jl")
include("msssim.jl")
include("colorfulness.jl")
include("entropy.jl")

if VERSION >= v"1.9.0"
    # It seems to be brittle to use `precompile` for old Julia versions (e.g., 1.7.3)
    # Since this only makes a huge difference after Julia 1.9, we only enable it for recent versions.
    include("precompile.jl")
end

export
    # generic
    assess,

    # Peak signal-to-noise ratio
    PSNR,
    assess_psnr,

    # Structral Similarity
    SSIM,
    assess_ssim,

    # Multi Scale Structural Similarity
    MSSSIM,
    assess_msssim,

    # Colorfulness
    HASLER_AND_SUSSTRUNK_M3,
    hasler_and_susstrunk_m3,
    colorfulness,

    # used to live in Images.jl
    entropy

@static if VERSION < v"1.1"
    isnothing(x) = x === nothing
end

end # module

"""
    MSSSIM([kernel], [W]; num_scales = length(W)) <: FullReferenceIQI
    assess(iqi::MSSSIM, img, ref)
    assess_msssim(img, ref; num_scales = 5)

Computes the multi-scale structural similarity (MS-SSIM) between two images.

!!! tip

    The default parameters comes from [1]. For benchmark usage, it is recommended to not
    change the parameters, because most other SSIM implementations follows the same settings.

# Examples

For benchmark usage, it is recommended to use `assess_msssim(img, ref)`. One could also create
a custom `MSSSIM` instance and then pass it to `assess` or use it as a function.

```julia
iqi = MSSSIM(KernelFactors.gaussian(2.5, 17), (1.0, 1.0, 2.0)./4)
assess(iqi, img, ref)
iqi(img, ref) # both usages are equivalent
```

# Reference

[1] Wang, Z., Simoncelli, E. P., & Bovik, A. C. (2003, November). Multiscale structural similarity for image quality assessment.In *The Thrity-Seventh Asilomar Conference on Signals, Systems & Computers*, 2003 (Vol. 2, pp. 1398-1402). Ieee.

[2] Wang, Z. IW-SSIM: Information Content Weighted Structural Similarity Index for Image Quality Assessment. Retrived July 9, 2020, from https://ece.uwaterloo.ca/~z70wang/research/iwssim/

[3] Jorge Pessoa. pytorch-msssim. Retrived July 9, 2020, from https://github.com/jorge-pessoa/pytorch-msssim

"""
struct MSSSIM{A, N} <: FullReferenceIQI
    kernel::A
    W::NTuple{N, NTuple{3, Float64}}

    function MSSSIM(kernel=SSIM_KERNEL, W=MSSSIM_W; num_scales::Integer=length(W))
        ndims(kernel) == 1 || throw(ArgumentError("only 1-d kernel is valid"))
        issymetric(kernel) || @warn "MSSSIM kernel is assumed to be symmetric"
        all(length.(W) .== 3) || throw(ArgumentError("(α, β, γ) required for all scales, instead it's $(W)"))
        (num_scales ∈ 1:length(W)) || throw(ArgumentError("`num_scales` $(num_scales) should be positive integer between [1, $(length(W))]"))
        all(x-> x>=0, flatten(W)) || throw(ArgumentError("α, β, γ should be non-negative for all scales, instead it's $(W)"))
        sum(flatten(W)) == 0 && throw(ArgumentError("MS-SSIM must have at least one weight > 0"))

        kernel = OffsetArrays.centered(kernel)
        if num_scales ≠ length(W)
            W ≠ MSSSIM_W && @warn "truncate MS-SSIM weights to scale $num_scales"
        end
        W = W[1:num_scales]
        sw = reduce((w1, w2) -> w1.+w2, W[1:num_scales])
        if !all(x -> x≈1.0, sw)
            W ≠ MSSSIM_W[1:num_scales] && @warn "normalize MS-SSIM weights so that (∑α, ∑β, ∑γ) == (1.0, 1.0, 1.0)"
            W = map(w->w./sw, W)
        end

        new{typeof(kernel), Int(num_scales)}(kernel, W)
    end
end
# Weights for α, β, γ in [1]
const MSSSIM_W = (
    (0.0448, 0.0448, 0.0448), # α₁, β₁, γ₁
    (0.2856, 0.2856, 0.2856), # α₂, β₂, γ₂
    (0.3001, 0.3001, 0.3001), # α₃, β₃, γ₃
    (0.2363, 0.2363, 0.2363), # α₄, β₄, γ₄
    (0.1333, 0.1333, 0.1333), # α₅, β₅, γ₅
)
# shorthand for αᵢ=βᵢ=γᵢ for all scales i
function MSSSIM(kernel, W::NTuple{N, <:Real}; num_scales=length(W)) where N
    MSSSIM(kernel, map(x->(x, x, x), W); num_scales=num_scales)
end

Base.:(==)(ia::MSSSIM, ib::MSSSIM) = ia.kernel == ib.kernel && ia.W == ib.W


# SSIM does not allow for user specifying peakval and K, so we don't allow it here either
(iqi::MSSSIM)(x, ref) = _msssim(iqi, x, ref)
assess_msssim(x, ref; num_scales=5) = MSSSIM(num_scales=num_scales)(x, ref)

# Implementation details
function _msssim(iqi::MSSSIM,
                 x::Union{GenericGrayImage, AbstractArray{<:AbstractRGB}},
                 ref::Union{GenericGrayImage, AbstractArray{<:AbstractRGB}};
                 peakval=1.0,
                 K=SSIM_K)
    if size(x) ≠ size(ref)
        err = ArgumentError("images should be the same size, instead they're $(size(x))-$(size(ref))")
        throw(err)
    end
    if axes(x) ≠ axes(ref)
        x = OffsetArrays.no_offset_view(x)
        ref = OffsetArrays.no_offset_view(ref)
    end
    C₁, C₂ = @. (peakval * K)^2
    C₃ = C₂/2

    num_scales = length(iqi.W)
    T = promote_type(float(eltype(ref)), float(eltype(x)))
    x = of_eltype(T, x)
    ref = of_eltype(T, ref)

    mean_lcs = NTuple{3, Float64}[]
    for i in 1:num_scales
        # instead of the original implementation that calculates mean(c .* s)
        # here we use a more general version mean(c) * mean(s)
        lcs = mean.(__ssim_map_general(x, ref, iqi.kernel, C₁, C₂, C₃; crop=true))
        push!(mean_lcs, lcs)

        # downsampling
        i == num_scales && break
        x = _average_pooling(x)
        ref = _average_pooling(ref)
    end

    # weighted them up, but only l of the last scale is used according to equation (7) in [1]
    mean_lcs = map(mean_lcs, iqi.W) do lcs, w
        # similar to SSIM, here we ensure that negative numbers in s are not being raised to powers
        # less than 1
        s = w[3] < 1 ? max(0, lcs[3]) : lcs[3]
        (lcs[1], lcs[2], s) .^ w
    end
    if length(mean_lcs) == 1
        return prod(first(mean_lcs))
    else
        return mapreduce(x->x[2]*x[3], *, mean_lcs[1:end-1]) * prod(mean_lcs[end])
    end
end

function _msssim(iqi::MSSSIM, x::AbstractArray{<:Color3}, ref::AbstractArray{<:Color3})
    C = ccolor(RGB, floattype(eltype(x)))
    _msssim(iqi, of_eltype(C, x), of_eltype(C, ref))
end

function _average_pooling(x::GenericImage; kernel=ones(2)./2)
    # note that this is slightly slower than two-fold method `ImageTransformations.restrict`
    window = ImageFiltering.kernelfactors(Tuple(repeated(kernel, ndims(x))))
    R = ntuple(i->first(axes(x, i)) : 2 : last(axes(x, i)), ndims(x))
    return ImageFiltering.imfilter(x, window, "symmetric")[R...]
end

using ImageCore
using IterTools

# AbstractGray and Color3 tests should be generated seperately
function generate_test_types(number_types::AbstractArray{<:DataType}, color_types::AbstractArray{<:UnionAll})
    test_types = map(Iterators.product(number_types, color_types)) do T
        try
            T[2]{T[1]}
        catch err
            !isa(err, TypeError) && rethrow(err)
        end
    end
    test_types = filter(x->x != false, test_types)
    if isempty(filter(x->x<:Color3, test_types))
        test_types = [number_types..., test_types...]
    end
    test_types
end

_base_colorant_type(::Type{<:Number}) = Gray
_base_colorant_type(::Type{T}) where T<:Colorant = base_colorant_type(T)
"""
    test_numeric(dist, a, b, T; filename=nothing, atol=1e-5)

simply test that `dist` works for 2d image as expected, more tests go to `Distances.jl`
"""
function test_numeric(dist, a, b, T; filename=nothing, atol=1e-5)
    size(a) == size(b) || error("a and b should be the same size")
    if filename == nothing
        filename = "references/$(typeof(dist))_$(ndims(a))d"

        if eltype(a) <: Color3
            filename = filename * "_$(_base_colorant_type(T))"
        elseif eltype(a) <: Union{Number, AbstractGray}
            filename = filename * "_$(_base_colorant_type(T))"
        end
    end
    @test_reference "$(filename).txt" Float64(assess(dist, a, b)) by=(x,y)->isapprox(x,y; atol=atol)
end

"""
    test_cross_type(dist, a, b, type_list)

simply test if operations between `N0f8`, `Bool` and `Float32` types works as expected.
`a` and `b` should be simple enough to get rid of InexactError.
"""
function test_cross_type(dist, a, b, type_list)
    size(a) == size(b) || error("a and b should be the same size")
    rsts = [[assess(dist, Ta.(a), Tb.(b)),
             assess(dist, Tb.(a), Ta.(b))] for (Ta, Tb) in subsets(type_list, 2)]
    rsts = hcat(rsts...)
    @test all(isapprox.(rsts, rsts[1]; rtol=1e-5))
end

function test_ndarray(d, sz, T)
    x = rand(T, sz)
    y = rand(T, sz)
    @test_nowarn assess(d, x, y)

    T <: AbstractGray || return nothing
    for _ in 1:10
        x = rand(T, sz)
        y = rand(T, sz)

        @test assess(d, x, y) ≈ assess(d, channelview(x), channelview(y)) atol=1e-4
    end
end
